/* 
 * Problem: 㶫ѵ Ȧ sphere
 * Author: Guo Jiabao
 * Time: 2009.6.9 9:02
 * State: Solved
 * Memo:  ǿͨ
*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
using namespace std;
const int MAXN=100003,MAXM=400003,INF=0x7FFFFFFF;
struct edge
{
	edge *next,*op;
	int t,c;
}*V[MAXN],ES[MAXM],*P[MAXN],*Stae[MAXN];
int N,M,EC,S,T,Stop,Dindex,Bcnt,Ans;
int Stap[MAXN],Lv[MAXN],DFN[MAXN],Low[MAXN],Bel[MAXN];
bool instack[MAXN];
inline void addedge(int a,int b)
{
	ES[++EC].next = V[a];
	V[a]=ES+EC; V[a]->t=b; V[a]->c=1;
	ES[++EC].next = V[b];
	V[b]=ES+EC; V[b]->t=a; V[b]->c=0;
	V[a]->op=V[b]; V[b]->op=V[a];
}
void init()
{
	int i,a,b;
	freopen("bloodsail.in","r",stdin);
	freopen("bloodsail.out","w",stdout);
	scanf("%d%d",&N,&M);
	for (i=1;i<=M;i++)
	{
		scanf("%d%d",&a,&b);
		addedge(a,b);
	}
	S=0; T=N+1;
	for (i=1;i+i<=N;i++)
	{
		addedge(S,i);
		addedge(i+N/2,T);
	}
}
bool level()
{
	int head=0,tail=0,i,j;
	Stap[tail]=S;
	memset(Lv,-1,sizeof(Lv));
	Lv[S]=0;
	while (head<=tail)
	{
		i=Stap[head++];
		for (edge *e=V[i];e;e=e->next)
		{
			j=e->t;
			if (e->c && Lv[j]==-1)
			{
				Lv[j] = Lv[i]+1;
				Stap[++tail]=j;
				if (j==T)
					return true;
			}
		}
	}
	return false;
}
void augment()
{
	int i,j,delta;
	for (i=S;i<=T;i++)
		P[i]=V[i];
	Stap[Stop=1]=S;
	while (Stop)
	{
		i=Stap[Stop];
		if (i!=T)
		{
			for (;P[i];P[i]=P[i]->next)
				if (P[i]->c && Lv[j=P[i]->t] == Lv[i] + 1)
					break;
			if (P[i])
			{
				Stap[++Stop]=j;
				Stae[Stop]=P[i];
			}
			else
			{
				Stop--;
				Lv[i]=-1;
			}
		}
		else
		{
			delta=INF;
			for (i=Stop;i>=2;i--)
				if (Stae[i]->c < delta)
					delta = Stae[i]->c;
			for (i=Stop;i>=2;i--)
			{
				Stae[i]->c -= delta;
				Stae[i]->op->c +=delta;
				if (Stae[i]->c==0)
					Stop=i-1;
			}
		}
	}
}
void dinic()
{
	while(level())
		augment();
}
void tarjan(int i)
{
	int j;
	DFN[i] = Low[i] = ++Dindex;
	Stap[++Stop] = i;
	instack[i] = true;
	for (edge *e = V[i] ;e;e=e->next)
	{
		j=e->t;
		if (e->c)
		{
			if (!DFN[j])
			{
				tarjan(j);
				if (Low[j] < Low[i])
					Low[i] = Low[j];
			}
			else if (instack[j] && DFN[j] < Low[i])
				Low[i] = DFN[j];
		}
	}
	if (DFN[i] == Low[i])
	{
		Bcnt++;
		do{
			j=Stap[Stop--];
			instack[j]=false;
			Bel[j]=Bcnt;
		}while (i!=j);
	}
}
void scc()
{
	int i;
	Stop=0;
	for (i=S;i<=T;i++)
		if (!DFN[i])
			tarjan(i);
}
void solve()
{
	int i,a,b;
	/*
	for (i=S;i<=T;i++)
		printf("%d: %d\n",i,Bel[i]);*/
	for (i=1;i<=M;i++)
	{
		edge *e=ES+i+i;
		a=e->t; b=e->op->t;
		if (e->c && Bel[a]!=Bel[b])
		{
			/*printf("%d %d\n",a,b);*/
			Ans++;
		}
	}
}
int main()
{
	init();
	dinic();
	scc();
	solve();
	printf("%d\n",Ans);
	return 0;
}
