/* 
 * Problem: kezan
 * Author: Guo Jiabao
 * Time: 2009.6.12 10:34
 * State: Solved
 * Memo: ˫ͨ ζ̬滮
*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
using namespace std;
const int MAXN=20001,MAXM=200001*4;
struct edge
{
	edge *next,*op;
	int t,c;
	bool vis,bridge;
}*V[MAXN],*A[MAXN],ES[MAXM],*R[MAXM];
int N,M,Dindex,Bcnt,RC,EC;
int Low[MAXN],DFN[MAXN],Bel[MAXN],F[MAXN],G[MAXN],D[MAXN];
inline void addedge(edge** V,int a,int b,int c)
{
	ES[++EC].next = V[a];
	V[a] = ES+EC; V[a]->t=b; V[a]->c=c;
	ES[++EC].next = V[b];
	V[b] = ES+EC; V[b]->t=a; V[b]->c=c;
	V[a]->op = V[b]; V[b]->op=V[a];
}
void init()
{
	int i,a,b,c;
	freopen("kezan.in","r",stdin);
	freopen("kezan.out","w",stdout);
	scanf("%d%d",&N,&M);
	for (i=1;i<=M;i++)
	{
		scanf("%d%d%d",&a,&b,&c);
		addedge(V,a,b,c);
	}
}
void tarjan(int i)
{
	Low[i] = DFN[i] = ++Dindex;
	for (edge *e=V[i];e;e=e->next)
	{
		if (e->vis) continue;
		e->vis = e->op->vis = true;
		int j=e->t;
		if (!DFN[j])
		{
			tarjan(j);
			if (Low[j] < Low[i])
				Low[i] = Low[j];
		}
		else if (DFN[j] < Low[i])
			Low[i] = DFN[j];
		if (DFN[i] < Low[j])
			e->bridge=e->op->bridge=true;
	}
}
void label(int i)
{
	Bel[i] = Bcnt;
	for (edge *e=V[i];e;e=e->next)
	{
		if (e->vis || e->bridge) continue;
		e->vis = e->op->vis = true;
		if (!Bel[e->t])
			label(e->t);
	}
}
void Bic()
{
	int i,a,b,T=EC;
	tarjan(1);
	for (i=1;i<=EC;i++)
		ES[i].vis=false;
	for (i=1;i<=N;i++)
	{
		if (!Bel[i])
		{
			Bcnt++;
			label(i);
		}
	}
	for (i=2;i<=T;i+=2)
	{
		a=ES[i].t; b=ES[i].op->t;
		if (Bel[a]!=Bel[b])
			addedge(A,Bel[a],Bel[b],ES[i].c);
	}
}
void calcdepth(int i,int f)
{
	F[i]=G[i]=0;
	for (edge *e=A[i];e;e=e->next)
	{
		int j=e->t;
		if (j==f || !j) continue;
		calcdepth(j,i);
		if (F[j] + e->c > F[i])
		{
			G[i] = F[i];
			F[i] = F[j] + e->c;
		}
		else if (F[j] + e->c > G[i])
			G[i] = F[j] + e->c;
	}
}
void dp(int i,int f,int h)
{
	D[i] = h;
	if (F[i] > D[i])
		D[i] = F[i];
	for (edge *e=A[i];e;e=e->next)
	{
		int j=e->t,k=h;
		if (j==f || !j) continue;
		if (F[j] + e->c == F[i] && G[i] > h)
			k = G[i];
		else if (F[j] + e->c < F[i] && F[i] > h)
			k = F[i];
		k += e->c;
		dp(j,i,k);
	}
}
void solve()
{
	Bic();
	calcdepth(1,0);
	dp(1,0,0);
	for (int i=1;i<=N;i++)
		printf("%d\n",D[Bel[i]]);
}
int main()
{
	init();
	solve();
	return 0;
}
