/* 
 * Problem: 
 * Author: Guo Jiabao
 * Time: 2009.6.12 15:00
 * Memo: ߶ + ƽ
*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
using namespace std;
const int MAXN=40001;
struct TreapNode
{
	TreapNode *c[2];
	int value,size,fix;
	int lsize() { return c[0]?c[0]->size:0; }
	int rsize() { return c[1]?c[1]->size:0; }
}TS[1000000];
int TC;
inline TreapNode *NEWTN()
{
	return TS + ++TC;
}
struct Treap
{
	TreapNode *root,*newnode;
	void update(TreapNode *x)
	{
		if (!x) return;
		x->size = 1;
		if (x->c[0])
			x->size += x->c[0]->size;
		if (x->c[1])
			x->size += x->c[1]->size;
	}
	void rotate(TreapNode *&x,int o)
	{
		TreapNode *y=x->c[o];
		x->c[o] = y->c[!o];
		y->c[!o] = x;
		update(x);
		update(y);
		x = y;
	}
	void insert(TreapNode *&x,int value)
	{
		if (!x)
		{
			if (newnode)
			{
				x=newnode;
				newnode=0;
			}
			else
			{
				x=NEWTN();
			}
			x->value = value;
			x->size = 1;
			x->c[0] = x->c[1] = 0;
			x->fix = rand();
		}
		else if (value < x->value)
		{
			insert(x->c[0],value);
			if (x->c[0]->fix < x->fix)
				rotate(x,0);
		}
		else
		{
			insert(x->c[1],value);
			if (x->c[1]->fix < x->fix)
				rotate(x,1);
		}
		update(x);
	}
	void remove(TreapNode *&x,int value)
	{
		if (value < x->value)
			remove(x->c[0],value);
		else if (value > x->value)
			remove(x->c[1],value);
		else
		{
			if (!x->c[0] || !x->c[1])
			{
				TreapNode *y=x;
				if (x->c[0])
					x = x->c[0];
				else
					x = x->c[1];
				newnode = y;
			}
			else if (x->c[0]->fix < x->fix)
			{
				rotate(x,0);
				remove(x->c[1],value);
			}
			else
			{
				rotate(x,1);
				remove(x->c[0],value);
			}
		}
		update(x);
	}
	int rank(TreapNode *x,int value)
	{
		if (!x) return 0;
		if (x->value < value)
			return x->lsize()+ 1 + rank(x->c[1],value);
		return rank(x->c[0],value);
	}
	int rrank(TreapNode *x,int value)
	{
		if (!x) return 0;
		if (x->value > value)
			return x->rsize()+ 1 + rrank(x->c[0],value);
		return rrank(x->c[1],value);
	}
	int getans(int value,bool bigger)
	{
		if (bigger)
			return rrank(root,value);
		else
			return rank(root,value);
	}
};
struct SegmentTree
{
	struct SgtNode
	{
		SgtNode *c[2];
		int a,b;
		Treap T;
	}*root,SS[MAXN*2];
	int SC;
	SgtNode *NewNode(int a,int b)
	{
		SS[++SC].a=a;SS[SC].b=b;
		SS[SC].c[0] = SS[SC].c[1] = 0;
		return SS+SC;
	}
	int getans(SgtNode *x,int a,int b,int v,bool bigger)
	{
		if (a>b) return 0;
		int m=(x->a + x->b) >> 1;
		if (x->a == a && x->b == b)
			return x->T.getans(v,bigger);
		if (b <= m)
			return getans(x->c[0],a,b,v,bigger);
		else if (a >= m+1)
			return getans(x->c[1],a,b,v,bigger);
		else
			return getans(x->c[0],a,m,v,bigger) + getans(x->c[1],m+1,b,v,bigger);
	}
	int modify(SgtNode *x,int k,int v)
	{
		int m=(x->a + x->b) >> 1,a;
		if (x->a==x->b)
		{
			a=x->T.root->value;
			x->T.root->value=v;
			return a;
		}
		if (k<=m)
			a=modify(x->c[0],k,v);
		else if (k>=m+1)
			a=modify(x->c[1],k,v);
		x->T.remove(x->T.root,a);
		x->T.insert(x->T.root,v);
		return a;
	}
	void build(SgtNode *&x,int a,int b,int *A)
	{
		x=NewNode(a,b);
		for (int i=a;i<=b;i++)
			x->T.insert(x->T.root,A[i]);
		if (a!=b)
		{
			int m=(a + b) >> 1;
			build(x->c[0],a,m,A);
			build(x->c[1],m+1,b,A);
		}
	}
}SGT;
int N,M,A[MAXN],Ans;
void init()
{
	freopen("twist.in","r",stdin);
	freopen("twist.out","w",stdout);
	scanf("%d%d",&N,&M);
	for (int i=1;i<=N;i++)
		scanf("%d",&A[i]);
	SGT.build(SGT.root,1,N,A);
}
void solve()
{
	int i,k,v,d;
	Ans = 0;
	for (i=1;i<=N;i++)
	{
		d  = SGT.getans(SGT.root,1,i-1,A[i],true);
		d += SGT.getans(SGT.root,i+1,N,A[i],false);
		Ans += d;
	}
	Ans = Ans >> 1;
	for (i=1;i<=M;i++)
	{
		scanf("%d%d",&k,&v);
		d = SGT.getans(SGT.root,1,k-1,A[k],true);
		d+= SGT.getans(SGT.root,k+1,N,A[k],false);
		Ans -= d;
		SGT.modify(SGT.root,k,v);
		A[k]=v;
		d = SGT.getans(SGT.root,1,k-1,A[k],true);
		d+= SGT.getans(SGT.root,k+1,N,A[k],false);
		Ans += d;
		printf("%d\n",Ans);
	}
}
int main()
{
	init();
	solve();
	return 0;
}
